unit timestuf;
interface
uses DOS;
Function Time_Stamp:string;
Function Date_Stamp:string;
{date/time stamp material, to be moved to its own unit later}
implementation
Function Time_Stamp:string;

VAR
  Hour,Minute,Second,Sec100 : Word;   {0..23, hour
                                       0..59, minute
                                       0..59, second
                                       0..99}
  S_Minute,S_Hour,AMPM : string;
BEGIN
  GetTime(Hour,Minute,Second,Sec100);
  if Hour > 12 then
    begin
      AMPM := 'PM';
      Hour := Hour - 12;
      end
      else
        AMPM := 'AM';
  Str(Hour:2,S_Hour);
  Str(Minute:2,S_Minute);
  Time_Stamp := S_Hour+AMPM+', '+S_Minute+' minutes';
END;
Function Date_Stamp:string;
CONST
  Month_Name : array[1..12] of string =
              ('January','February','March','April','May','June',
              'July','August','September','October','November','December');
  Day_Name : array[0..6] of string =
             ('Sunday','Monday','Tuesday','Wednesday','Thursday',
              'Friday','Saturday');
VAR
  Year,Month,Day,DayofWeek : Word;    {1980..2099, year
                                       1..12, month
                                       1..31, day
                                       0..6, Sunday .. Saturday}


  S_Day,S_Year : string;
BEGIN
  GetDate(Year,Month,Day,DayOfWeek);
  Str(Day:2,S_day);
  Str(Year:4,S_Year);

  Date_Stamp := Day_Name[DayofWeek]+' '+Month_Name[Month]+' '+
                     S_Day+', '+S_Year;
END;
END.
